Package com.io7m.waxmill.xml.vm.v1

# Class WXM1LinuxKernelDevice.Builder

java.lang.Object
com.io7m.waxmill.xml.vm.v1.WXM1LinuxKernelDevice.Builder

Enclosing class:
  WXM1LinuxKernelDevice

    public static final class WXM1LinuxKernelDevice.Builder
    extends java.lang.Object

Builds instances of type `WXM1LinuxKernelDevice`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `WXM1LinuxKernelDevice` | `build()` | Builds a new `WXM1LinuxKernelDevice`.
  `WXM1LinuxKernelDevice.Builder` | `from​(WXM1LinuxKernelDeviceType instance)` | Fill a builder with attribute values from the provided `WXM1LinuxKernelDeviceType` instance.
  `WXM1LinuxKernelDevice.Builder` | `setDeviceSlot​(WXMDeviceSlot deviceSlot)` | Initializes the value for the `deviceSlot` attribute.
  `WXM1LinuxKernelDevice.Builder` | `setKernelPath​(java.nio.file.Path kernelPath)` | Initializes the value for the `kernelPath` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final WXM1LinuxKernelDevice.Builder from​(WXM1LinuxKernelDeviceType instance)
    Fill a builder with attribute values from the provided `WXM1LinuxKernelDeviceType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setDeviceSlot

    public final WXM1LinuxKernelDevice.Builder setDeviceSlot​(WXMDeviceSlot deviceSlot)
    Initializes the value for the `deviceSlot` attribute.
    Parameters:
      `deviceSlot` - The value for deviceSlot
    Returns:
      `this` builder for use in a chained invocation

  - ### setKernelPath

    public final WXM1LinuxKernelDevice.Builder setKernelPath​(java.nio.file.Path kernelPath)
    Initializes the value for the `kernelPath` attribute.
    Parameters:
      `kernelPath` - The value for kernelPath
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public WXM1LinuxKernelDevice build()
    Builds a new `WXM1LinuxKernelDevice`.
    Returns:
      An immutable instance of WXM1LinuxKernelDevice
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing